#include <windows.h>
#include <math.h>
#ifndef M_PI
#define	M_PI  3.14159265358979323846
#endif
#include <stdio.h>
#include "resource.h"

#define NAXE 21
HWND hDlgConfRov = NULL;			// hwnd de la bote de dialogue
static WNDPROC StdEditConfProc;		// Memo procedure standard du controle d'dition
static HWND hEdit[NAXE];

#define VALIDE	500				// IDC bouton virtuel valide
#define ANNULE	501				// IDC bouton virtuel annule


/* Procedure interceptant les entres au control-edit IDC_EDIT1 pour simuler les
   action valide/annule avec RETURN/ESCAPE */
LRESULT CALLBACK ConfEditProc (HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	/* Si reoit un return ou un escape,  on simule l'appui sur 
       des boutons virtuels valide ou annule */
    if (iMsg == WM_CHAR)
	{
		if(wParam == VK_RETURN)
		{
			SendMessage (hDlgConfRov, WM_COMMAND, MAKELONG(VALIDE,0), (LPARAM) hWnd);
			return 0;
		}
		if (wParam == VK_ESCAPE)
		{
			SendMessage (hDlgConfRov, WM_COMMAND, MAKELONG(ANNULE,0), (LPARAM) hWnd); 
			return 0;
		}
	}

    return CallWindowProc (StdEditConfProc, hWnd, iMsg, wParam, lParam) ;
}

static int idc_edit[NAXE] = {IDC_EDIT1, IDC_EDIT2, IDC_EDIT3, IDC_EDIT4, IDC_EDIT5,
							IDC_EDIT6, IDC_EDIT7, IDC_EDIT8, IDC_EDIT9, IDC_EDIT10,
							IDC_EDIT11, IDC_EDIT12, IDC_EDIT13, IDC_EDIT14, IDC_EDIT15,
							IDC_EDIT16, IDC_EDIT17, IDC_EDIT18, IDC_EDIT19, IDC_EDIT20, IDC_EDIT21};
static int idc_static[NAXE] = {IDC_STATIC1, IDC_STATIC2, IDC_STATIC3, IDC_STATIC4, IDC_STATIC5,
							IDC_STATIC6, IDC_STATIC7, IDC_STATIC8, IDC_STATIC9, IDC_STATIC10,
							IDC_STATIC11, IDC_STATIC12, IDC_STATIC13, IDC_STATIC14, IDC_STATIC15,
							IDC_STATIC16, IDC_STATIC17, IDC_STATIC18, IDC_STATIC19, IDC_STATIC20, IDC_STATIC21};
static int idc_scroll[NAXE] = {IDC_SCROLLBAR1, IDC_SCROLLBAR2, IDC_SCROLLBAR3, IDC_SCROLLBAR4, IDC_SCROLLBAR5,
							IDC_SCROLLBAR6, IDC_SCROLLBAR7, IDC_SCROLLBAR8, IDC_SCROLLBAR9, IDC_SCROLLBAR10,
							IDC_SCROLLBAR11, IDC_SCROLLBAR12, IDC_SCROLLBAR13, IDC_SCROLLBAR14, IDC_SCROLLBAR15,
							IDC_SCROLLBAR16, IDC_SCROLLBAR17, IDC_SCROLLBAR18, IDC_SCROLLBAR19, IDC_SCROLLBAR20,IDC_SCROLLBAR21};
static double Valmin[NAXE] = { -85., 85., -185., 5., -45.,-85., -25., -25., -25., -45., -45., -30., -30., -45., -45., -180., -180., -180., -180., -180., -180.};
static double Valmax[NAXE] = { 85., -85.,  -5.,185., 85.,  45.,  25.,  25.,  25.,  45.,  45.,  30.,  30.,  45.,  45.,  180.,  180.,  180.,  180.,  180.,  180.};
static double val_mem[NAXE];
extern double conf_rov[];
void UpdateRov(int fmodconf, int fmodvue, int fmodsit);

/* Call back traitant les messages de la bote de dialogue */
BOOL CALLBACK DialogConfRov(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{
#define MAXSCROLL 1000
static HWND hScroll[NAXE];
static int ix_mem[NAXE];
int ix, numax;
#define MAXCHAR1 20
char text[MAXCHAR1+1]="";
int n;

    switch (message) 
	{ 
	case WM_INITDIALOG :
//#define MODALE_cad_BLOQUE
#ifdef MODALE_cad_BLOQUE
		hDlgConfRov = hDlg;
#endif
		/* On sous-classe le control-edit*/
		for (n=0; n<NAXE; n++)
		{
			hEdit[n] = GetDlgItem (hDlg, idc_edit[n]);
			StdEditConfProc = (WNDPROC) SetWindowLong(hEdit[n], GWL_WNDPROC, (LONG) ConfEditProc);
			/* On affiche les valeurs initiales  l'afficheur et  l'editeur */
			val_mem[n] = conf_rov[n]*180./M_PI;
			/* On ramme les tours de roue entre -180 et + 180. */
			if (n > 14) val_mem[n] -= 360.*floor((val_mem[n] + 180.)/360.);
			sprintf(text,"%5.2lf",val_mem[n]);
			SetDlgItemText(hDlg, idc_edit[n], text);
			SetDlgItemText(hDlg, idc_static[n], text);
			/* On initialise le curseur */
			hScroll[n] = GetDlgItem (hDlg, idc_scroll[n]);
			SetScrollRange (hScroll[n] , SB_CTL, 0, MAXSCROLL, FALSE) ;
			/* On positionne le curseur  la valeur initiale */
			ix_mem[n] = (int) (MAXSCROLL*(val_mem[n] - Valmin[n])/(Valmax[n]-Valmin[n]));
			SetScrollPos (hScroll[n], SB_CTL, ix_mem[n], TRUE) ;
		}
		return TRUE ;

    case WM_COMMAND :
		numax = -1;
		for (n=0; n<NAXE; n++) if(hEdit[n] == (HWND) lParam) { numax = n; break;}
        switch (LOWORD(wParam)) 
		{ 
		case VALIDE : /* Valide dans fenetre edit */
			if (numax < 0) break;
			/* lecture texte du controle edition */
			n = GetDlgItemText(hDlg, idc_edit[numax], text, MAXCHAR1);
			/* test des valeurs / aux limites */
			if (n)
			{
				n = sscanf(text,"%lf",&val_mem[numax]);
				if (n!=1) val_mem[numax] = 0.;
				if (val_mem[numax] < Valmin[numax])
				{
					val_mem[numax] = Valmin[numax];
					MessageBeep(0xFFFFFFFF);
				}
				if (val_mem[numax] > Valmax[numax])
				{
					val_mem[numax] = Valmax[numax];
					MessageBeep(0xFFFFFFFF);
				}
			}
			/* On va afficher la valeur et mettre le curseur en place */
			ix_mem[numax] = (int) (MAXSCROLL*(val_mem[numax] - Valmin[numax])/(Valmax[numax]-Valmin[numax]));
		case ANNULE : /* annule dans fenetre edit, ou fin du valide */
			/* On affiche et on positionne le curseur avec les valeurs _mem */
			if (numax < 0) break;
			sprintf(text,"%5.2lf",val_mem[numax]);
			SetDlgItemText(hDlg, idc_edit[numax], text);
			SetDlgItemText(hDlg, idc_static[numax], text);
			SetScrollPos (hScroll[numax], SB_CTL, ix_mem[numax], TRUE) ;
			conf_rov[numax] = val_mem[numax]*M_PI/180.;
			UpdateRov(1,0,0);
			return TRUE;

		case IDCANCEL :
#ifdef MODALE_cad_BLOQUE
			EndDialog (hDlg, 0) ;
#else
			DestroyWindow(hDlg);
#endif
			hDlgConfRov = NULL;
//		    PostQuitMessage (0) ; // On envoie le WM_QUIT- On TUE l'application
			return TRUE ;
        } /* Fin du switch (LOWORD(wParam)) dans WM_COMMAND */
		break ; /* Fin du WM_COMMAND */

	case WM_VSCROLL :
	case WM_HSCROLL :
		numax = -1;
		for (n=0; n<NAXE; n++) if(hScroll[n] == (HWND) lParam) { numax = n; break;}
		if (numax < 0) return FALSE ;
		ix = ix_mem[numax];
		switch (LOWORD(wParam))
		{
		case SB_PAGEDOWN : 
			ix += MAXSCROLL/20 ;
			break ;
		case SB_LINEDOWN :
			++ix ;
			break ;
		case SB_PAGEUP : 
			ix -= MAXSCROLL/20 ;
			break ;
		case SB_LINEUP :
			--ix ;
			break ;
		case SB_TOP :
			ix = 0 ;
			break ;
		case SB_BOTTOM :
			ix = MAXSCROLL ;
			break ;
		case SB_THUMBPOSITION :
		case SB_THUMBTRACK :
			ix = HIWORD (wParam) ;
			break ;
		default :
			return FALSE ;
		} /* Fin du switch (LOWORD(wParam)) dans WM_VSCROLL */

		ix = ix < MAXSCROLL ? ix : MAXSCROLL ;
		ix = ix > 0 ? ix : 0 ;

		if (ix != ix_mem[numax])
		{
				ix_mem[numax] = ix ;
				SetScrollPos (hScroll[numax], SB_CTL, ix, TRUE) ;
				val_mem[numax] = Valmin[numax] + (Valmax[numax]-Valmin[numax])*ix_mem[numax]/MAXSCROLL;
				sprintf(text,"%5.2lf",val_mem[numax]);
				SetDlgItemText(hDlg, idc_edit[numax], text);
				SetDlgItemText(hDlg, idc_static[numax], text);
				conf_rov[numax] = val_mem[numax]*M_PI/180.;
				UpdateRov(1,0,0);
		}
		return TRUE ; /* Fin du WM_VSCROLL */
	} /* Fin du switch (message) */

    return FALSE; 
} 

#if 0
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{ 
MSG  msg ;


	hDlgConfRov = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), (HWND) NULL, 
			(DLGPROC)DialogConfRov) ;
	ShowWindow (hDlgConfRov, SW_SHOW) ;


	while (GetMessage (&msg, NULL, 0, 0))
	{ 
		TranslateMessage (&msg) ;	
		DispatchMessage (&msg) ;
	}
	return msg.wParam ;
}
#endif