/* MANIPULATION VECTEURS DE R3 avec possibilite de partage de memoire */

void nulvec (double *a);
/* (a) = 0 */

void cpyvec (double *a, double *b);
/* (a) = (b) */

void scavec (double *a, double s, double *b);
/* (a) = s.(b) */

void addvec (double *u, double *v, double *w);
/* (u) = (v)+(w) */

void subvec (double *u, double *v, double *w);
/* (u) = (v)-(w) */

void cumvec (double *u, double *v, double a, double *w);
/* (u) = (v)+a.(w) */

/* MANIPULATION MATRICES 3x3 avec possibilite de partage de memoire */

void matiden (double *a);
/* [a] = I */

void cpymat (double *a, double *b);
/* [a] = [b] */

/* MANIPULATION MATRICES VECTEURS DE R3
				avec possibilite de partage de memoire */

void madvec (double *a, double *b, double *c);
/* (a) = [b].(c) */

/* MANIPULATION MATRICE POSITION-ORIENTATION */

void pordpord (double *a, double *b, double *c);
/* [a] = [b].[c] */

void pordvec (double *a, double *b, double *c);
/* (a) = [b].(c) */

/* MANIPULATION MATRICE VECTEUR ROTATION */

void mrotva (double *r, double *u, double a);
/* [r] = Rot{(u),a}, u doit tre  unitaire */

void mrotna (double *r, int n, double a);
/* [r] = Rot{(u),a}, (u) axe de base numro n */

void ltrmat (double *a, double *ltr) ;
/* matrice de rotation pour les angles l, t, r */
